﻿using System.Collections.ObjectModel;
using System.ComponentModel;

namespace RadGridView_SL4_AR_16
{
	/// <summary>
	/// A football player.
	/// </summary>
	public class Player : INotifyPropertyChanged
	{
		public event PropertyChangedEventHandler PropertyChanged;

		private string name;
		private int number;
		private Position position;
		private string country;
		private bool isCaptain;

		public bool IsCaptain
		{
			get
			{
				return this.isCaptain;
			}
			set
			{
				if (this.isCaptain != value)
				{
					this.isCaptain = value;
					this.OnPropertyChanged("IsCaptain");
				}
			}
		}
		
		public string Name
		{
			get
			{
				return this.name;
			}
			set
			{
				if (value != this.name)
				{
					this.name = value;
					this.OnPropertyChanged("Name");
				}
			}
		}

		public int Number
		{
			get
			{
				return this.number;
			}
			set
			{
				if (value != this.number)
				{
					this.number = value;
					this.OnPropertyChanged("Number");
				}
			}
		}

		public Position Position
		{
			get
			{
				return this.position;
			}
			set
			{
				if (value != this.position)
				{
					this.position = value;
					this.OnPropertyChanged("Position");
				}
			}
		}

		public string Country
		{
			get
			{
				return this.country;
			}
			set
			{
				if (value != this.country)
				{
					this.country = value;
					this.OnPropertyChanged("Country");
				}
			}
		}

		public Player()
		{
		}

		public Player(string name, int number, Position position, string country, bool isCaptain)
		{
			this.name = name;
			this.number = number;
			this.position = position;
			this.country = country;
			this.isCaptain = isCaptain;
		}

		protected virtual void OnPropertyChanged(PropertyChangedEventArgs args)
		{
			PropertyChangedEventHandler handler = this.PropertyChanged;
			if (handler != null)
			{
				handler(this, args);
			}
		}

		private void OnPropertyChanged(string propertyName)
		{
			this.OnPropertyChanged(new PropertyChangedEventArgs(propertyName));
		}

		public override string ToString()
		{
			return this.Name;
		}

		public static ObservableCollection<Player> GetPlayers()
		{
			ObservableCollection<Player> players = new ObservableCollection<Player>();

			players.Add(new Player("Pepe Reina", 25, Position.GK, "Spain", true));
			players.Add(new Player("Jamie Carragher", 23, Position.DF, "England", false));
			players.Add(new Player("Steven Gerrard", 8, Position.MF, "England", false));
			players.Add(new Player("Fernando Torres", 9, Position.FW, "Spain", true));

			return players;
		}
	}
}
